<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { onUpdated, ref, onMounted, watch, inject } from 'vue';
import { useI18n } from 'vue-i18n';
import { request } from '@/lib/request';
import { useMetaStore } from '@/stores/meta';
import Modal from '@/components/general/Modal.vue';
import PasswordField from '@/components/general/form/PasswordField.vue';
import { storeToRefs } from 'pinia';
import { adminMenuEnum } from '@/enums/enums';

const { t } = useI18n();
const $t = t; 

const store = useMetaStore();
const { openMenu } = storeToRefs(store);

const props = defineProps<{
    modelValue?: Boolean
}>();

let configuration = inject<any>('configuration');

const emits = defineEmits<{
    //(e: "update:modelValue", value:boolean):void,
    (e: "close", value:boolean):void,
}>();

const submitModal = async ()=>{
    try{
        let response = await request('POST', configuration.apiServer + '/api/password_reset/'+ store.hashcode, 
            {modPassword: modPassword.value, panePassword: panePassword.value }, 'application/json', false, true);
        if(response && response.success){
            showSuccessModal.value = true;
        }
    }catch(error){
        console.error(error);
        showError.value = true;
    }
}

const closeModal = ()=>{
    //emits('close', false);
    openMenu.value = adminMenuEnum.NONE;
}

const modPassword = ref('');
const mPasswordValid = ref(true);
const panePassword = ref('');
const pPasswordValid = ref(true);
const showError = ref(false);
const showSuccessModal = ref(false);


</script>
<template>
<div>
    <Modal :header="$t('general.variables.password.sg') + ' ' + $t('general.variables.change')" 
        :labelCancel="$t('general.buttons.cancel')" 
        :labelSubmit="$t('general.buttons.send')" 
        :disableSubmit="!(((modPassword && modPassword.length>=8 && mPasswordValid) 
        && (panePassword && panePassword.length>=6 && pPasswordValid))
        ||(modPassword && modPassword.length>=8 && mPasswordValid && !panePassword) 
        || (panePassword && panePassword.length>=6 && pPasswordValid && !modPassword))" @submit="submitModal" @cancel="closeModal" @close="">
        <p class="text-red-700" v-if="showError">{{$t('general.errors.unexpected')}}</p>
        <PasswordField v-model="modPassword"  v-model:valid="mPasswordValid" :label="$t('indexPage.buttonTexts.login.tabs.mod') + ' ' + $t('general.variables.password.sg')" :strong="true" :errorText="$t('adminMenu.passwordReset.error.password.strong')" />
        <PasswordField v-model="panePassword" v-model:valid="pPasswordValid" :label="$t('indexPage.buttonTexts.login.tabs.user') + ' ' + $t('general.variables.password.sg')" :strong="false" :errorText="$t('adminMenu.passwordReset.error.password.user')" />
        <Modal :text="$t('adminMenu.passwordReset.success')" :labelSubmit="$t('general.buttons.ok')" @submit="closeModal" v-if="showSuccessModal"/>
    </Modal>
</div>
</template>